//-----------------Intrinsic Viriations------------/
//--------------Lu Liu-----------------------------------/
//----------------------------M265 2016 Spring------------------/
//This project have three modes: 1.Lines 2. Blue 3.Colorful (Press '1','2','3' to switch)
//Press 'R' to rotate camera
//Press 'B' to set a black background, 'W' to set a white background
//Press 'D' to show delay tails, Press 'B'to stop this delay effect. 
// !! This delay effect only happens under black background


//Reference:
// 1."Making Things See" by Greg Borenstein
// 2. HE_Mesh* is a Java library for creating and manipulating polygonal meshes. It could be downloaded at http://www.wblut.com/#hemesh
// 3. Sounds Effect http://soundbible.com/suggest.php?q=nail&x=0&y=0



import wblut.math.*;
import wblut.processing.*;
import wblut.geom.*;
import wblut.core.*;
import wblut.hemesh.*;
import java.util.List;
import peasy.*;
int maxRange=2300, minRange=600;
float closestValue;
float closestX;
float closestY;
PeasyCam cam;

import ddf.minim.*;

Minim minim;
AudioPlayer noise;
AudioPlayer strange;

int i=0;
boolean lines = false;
boolean blues = false;
boolean colors = false;
boolean backBlack=true;
boolean backWhite=false;
boolean beginRY=false;

float px, py, pz;

import processing.opengl.*;
import SimpleOpenNI.*;
SimpleOpenNI kinect;
SimpleOpenNI context;
PVector      com = new PVector(); 

import controlP5.*;
ControlP5 cp5;

List<WB_Point> points;
List<WB_Point> GEpoints;
List<WB_VoronoiCell3D> voronoi;

WB_Render3D render;
WB_GeometryFactory gf=WB_GeometryFactory.instance();
WB_AABB box;

HE_Mesh mesh;
WB_Render renderHull;
HEC_ConvexHull creator;


int inNum;
int variation;
int speedFrame;

color[]  userClr = new color[] { 
  color(0, 0, 255, 50), 
  color(0, 0, 255, 50), 
  color(0, 0, 255, 50), 
  color(0, 0, 255, 50), 
  color(0, 0, 255, 50), 
  color(0, 0, 255, 50)
};


float rotation=0;
void setup() {
  //  size(1200, 800, OPENGL);
  size(displayWidth, displayHeight, OPENGL);
  background(0);
  smooth(8);

  render= new WB_Render3D(this);
  cam = new PeasyCam(this, 1900);
  // cam.setMaximumDistance(5000);

  cp5 = new ControlP5(this);


  cp5.addSlider("Inside_Cells")
    .setColorLabel(130) 
      .setPosition(20, 60)
        .setSize(100, 15)
          .setRange(140, 200)
            .setValue(150)
              ;

  cp5.addSlider("Variations")
    .setColorLabel(130) 
      .setPosition(20, 85)
        .setSize(100, 15)
          .setRange(5, 40)
            .setValue(20)
              ;


  cp5.addSlider("Fluid_Speed")
    .setColorLabel(130) 
      .setPosition(20, 110)
        .setSize(100, 15)
          .setRange(1, 60)
            .setValue(50)
              ;
              
//          cp5.addButton("Black")
//          .setPosition()
//          .setSize()
//          ;
//          
//          cp5.addButton("White")
//             .setPosition()
//          .setSize();
//          
//          

  cp5.setAutoDraw(false);


  kinect = new SimpleOpenNI(this);
  kinect.enableDepth();
  kinect.enableRGB();
  kinect.alternativeViewPointDepthToImage();
  kinect.setMirror(true);
  kinect.enableUser();


  points=new ArrayList<WB_Point>();
  // add points to collection


  println("Steup Ready!");

  //  creator=new HEC_ConvexHull();

  //  long key=0;
  //  HE_Vertex v= mesh.getVertexByKey(key);
  //  println("# vertices: "+ mesh.getNumberOfVertices());
  //  textAlign(CENTER);


  minim = new Minim(this);
  //noise = minim.loadFile( "bg.wav", 512 // buffer size
  //);
  //noise.loop();
//  println("lu: " + noise.getVolume());
  strange = minim.loadFile( "Strange.wav", 512 // buffer size
  );
}

void draw() {
  //  background(255);
  frameRate(speedFrame);
  if (backBlack==true)background(0);
  if (backWhite==true)background(255);

  gui();

  //  directionalLight(255, 255, 255, 1, 1, -1);
  //  directionalLight(127, 127, 127, -1, -1, 1);

  kinect.update();
  //  context.update();
  PImage rgbImage= kinect.rgbImage();
  rotateX(radians(180)); 


  for (int i=0; i<8; i++) {
    for (int j=0; j<7; j++) {
      for (int k=0; k<8; k++) {
        points.add(new WB_Point(-800+i*200+random(-variation, variation), -700+j*200+random(-variation, variation), -800+k*200+random(-variation, variation)));

        //          points.add(new WB_Point(-1500+i*375, -1500+j*375, -1500+k*375));
      }
    }
  }

  PVector[] depthPoints = kinect.depthMapRealWorld(); 
  for (int i = 0; i < depthPoints.length; i+=200) {
    PVector currentPoint = depthPoints[i];

    if (currentPoint.z > minRange && currentPoint.z < maxRange) {

      points.add(new WB_Point(currentPoint.x, currentPoint.y, currentPoint.z-1500));
    }
  }



  //  container=new HE_Mesh(new HEC_Box().setWidth(500).setHeight(500).setDepth(500));
  //creator.setPoints(points);
  //mesh=new HE_Mesh(creator);
  //renderHull=new WB_Render(this);
  //noStroke();
  //render.drawEdges(mesh);
  noFill();
  //render.drawFaces(mesh);
  //  translate(0,0,1000);
  //  box=new WB_AABB(-800, -800, -800, 800, 800, 800);
  box=new WB_AABB(-800, -700, -800, 800, 700, 800);


  voronoi= WB_Voronoi.getVoronoi3D(points, box);
  //    println("Before: " + points.size());
  //  noFill();
  //  strokeWeight(2);
  //  render.drawPoints(points, 1); 
  strokeWeight(1);

  //      startRotateY();
  //      cam.rotateY(PI/3);
  if (lines==true)line();
  if (blues==true)blue();
  if (colors==true)colorful();


  //println("Before: " + points.size());
  points.clear();
 // println("After: " + points.size());
}

void gui() {

  cam.beginHUD();
  noStroke();

  cp5.draw();
  cam.endHUD();
}
